import { loadConfig } from "c12";
import { setDefaultConfig } from "./setDefaultConfig.js";
export async function loadPgTConfig(options) {
    let result = await loadConfig({
        configFile: "pgt.config",
        dotenv: true,
        globalRc: true,
        name: "pgt",
        rcFile: ".pgtrc",
        ...options,
    });
    if (!result.config || Object.keys(result.config).length === 0) {
        result = await loadConfig({
            configFile: "postgresql-typed.config",
            dotenv: true,
            globalRc: true,
            name: "postgresql-typed",
            rcFile: ".postgresql-typedrc",
            ...options,
        });
    }
    return {
        config: await setDefaultConfig(result.config ?? {}),
        configFile: !result.config || Object.keys(result.config).length === 0 ? undefined : result.configFile,
        cwd: !result.config || Object.keys(result.config).length === 0 ? undefined : result.cwd,
    };
}
//# sourceMappingURL=loadPgTConfig.js.map