import { getParsedType } from "./getParsedType.js";
export const hasKeys = (object, keys) => {
    const objectKeys = Object.keys(object), otherKeys = objectKeys.filter(key => !keys.some(([k]) => k === key)), missingKeys = keys.filter(([k, v]) => !objectKeys.includes(k) && !v.includes("undefined")).map(([k]) => k), invalidKeys = keys
        .map(([k, t]) => {
        if (!(k in object) && !t.includes("undefined")) {
            return {
                expected: t,
                objectKey: k,
                received: "undefined",
            };
        }
        const objectType = getParsedType(object[k]);
        if (Array.isArray(t) && t.includes(objectType))
            return undefined;
        else if (objectType === t)
            return undefined;
        return {
            expected: t,
            objectKey: k,
            received: objectType,
        };
    })
        .filter((v) => v !== undefined);
    if (otherKeys.length > 0 || missingKeys.length > 0 || invalidKeys.length > 0) {
        return {
            invalidKeys,
            missingKeys,
            otherKeys,
            success: false,
        };
    }
    if (objectKeys.length === 0) {
        return {
            invalidKeys,
            missingKeys: keys.map(([k]) => k),
            otherKeys,
            success: false,
        };
    }
    return {
        obj: object,
        success: true,
    };
};
//# sourceMappingURL=hasKeys.js.map